]> git.saurik.com Git - bison.git/blobdiff - tests/synclines.at
Regenerate.
[bison.git] / tests / synclines.at
index c7501fdee9612d5dc415722a01f376c33ce203a1..e10f3c6364c55b355a0a2ddaf27c0f4dbe15196e 100644 (file)
@@ -1,5 +1,5 @@
 # Executing Actions.                               -*- Autotest -*-
 # Executing Actions.                               -*- Autotest -*-
-# Copyright 2002 Free Software Foundation, Inc.
+# Copyright (C) 2002, 2004 Free Software Foundation, Inc.
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 
 AT_BANNER([[User Actions.]])
 
 
 AT_BANNER([[User Actions.]])
 
+
+# AT_SYNCLINES_COMPILE(FILE)
+# --------------------------
+# Compile FILE expecting an error, and save in the file stdout the
+# normalized output.  Ignore the exit status, since some compilers
+# (e.g. c89 on IRIX 6.5) triger warnings on `#error', instead of
+# errors.
+m4_define([AT_SYNCLINES_COMPILE],
+[AT_CHECK([$CC $CFLAGS $CPPFLAGS -c $1], [ignore], [], [stderr])
+# In case GCC displays column information, strip it down.
+#
+#   input.y:4:2: #error "4"    or input.y:4.2: #error "4"
+# =>
+#   input.y:4: #error "4"
+#
+AT_CHECK([[sed 's/^\([^:]*:[^:.]*\)[.:][^:]*:\(.*\)$/\1:\2/' stderr]], 0, [stdout])
+])
+
 # AT_TEST_SYNCLINE(TITLE, INPUT, ERROR-MSG)
 # -----------------------------------------
 # Check that compiling the parser produced from INPUT cause GCC
 # AT_TEST_SYNCLINE(TITLE, INPUT, ERROR-MSG)
 # -----------------------------------------
 # Check that compiling the parser produced from INPUT cause GCC
@@ -25,15 +43,34 @@ AT_BANNER([[User Actions.]])
 m4_define([AT_TEST_SYNCLINE],
 [AT_SETUP([$1])
 
 m4_define([AT_TEST_SYNCLINE],
 [AT_SETUP([$1])
 
-# I'm not sure I can find a generic scheme to check the location
-# of an error, so we keep this for GCC only.
-AT_CHECK([test "$GCC" = yes || exit 77])
-
-AT_DATA([[input.y]],
-[$2])
-
-AT_CHECK([bison input.y -o input.c])
-AT_CHECK([$CC $CFLAGS $CPPFLAGS input.c -o input], 1, [], [$3])
+# It seems impossible to find a generic scheme to check the location
+# of an error.  Even requiring GCC is not sufficient, since for instance
+# the version modified by Apple:
+#
+# | Reading specs from /usr/libexec/gcc/darwin/ppc/2.95.2/specs
+# | Apple Computer, Inc. version gcc-934.3, based on gcc version 2.95.2
+# | 19991024 (release) configure:2124: $? = 0
+#
+# instead of:
+#
+# | input.y:2: #error "2"
+#
+# it reports:
+#
+# | input.y:2: "2"
+# | cpp-precomp: warning: errors during smart preprocessing, retrying in basic mode
+
+AT_DATA([syncline.c],
+[[#error "1"
+]])
+
+AT_SYNCLINES_COMPILE([syncline.c])
+AT_CHECK([[test "`cat stdout`" = 'syncline.c:1: @%:@error "1"' || exit 77]])
+
+AT_DATA([[input.y]], [$2])
+AT_CHECK([bison -o input.c input.y])
+AT_SYNCLINES_COMPILE([input.c])
+AT_CHECK([cat stdout], 0, [$3])
 AT_CLEANUP
 ])
 
 AT_CLEANUP
 ])
 
@@ -46,6 +83,8 @@ AT_CLEANUP
 AT_TEST_SYNCLINE([Prologue synch line],
 [[%{
 #error "2"
 AT_TEST_SYNCLINE([Prologue synch line],
 [[%{
 #error "2"
+void yyerror (const char *s);
+int yylex (void);
 %}
 %%
 exp: '0';
 %}
 %%
 exp: '0';
@@ -61,7 +100,12 @@ exp: '0';
 AT_TEST_SYNCLINE([%union synch line],
 [[%union {
 #error "2"
 AT_TEST_SYNCLINE([%union synch line],
 [[%union {
 #error "2"
+  char dummy;
 }
 }
+%{
+void yyerror (const char *s);
+int yylex (void);
+%}
 %%
 exp: '0';
 ]],
 %%
 exp: '0';
 ]],
@@ -75,19 +119,20 @@ exp: '0';
 
 AT_TEST_SYNCLINE([Postprologue synch line],
 [[%{
 
 AT_TEST_SYNCLINE([Postprologue synch line],
 [[%{
-/* Nothing here. */
+void yyerror (const char *s);
+int yylex (void);
 %}
 %union
 {
   int ival;
 }
 %{
 %}
 %union
 {
   int ival;
 }
 %{
-#error "9"
+#error "10"
 %}
 %%
 exp: '0';
 ]],
 %}
 %%
 exp: '0';
 ]],
-[input.y:9: #error "9"
+[input.y:10: #error "10"
 ])
 
 
 ])
 
 
@@ -96,13 +141,17 @@ exp: '0';
 ## ------------------- ##
 
 AT_TEST_SYNCLINE([Action synch line],
 ## ------------------- ##
 
 AT_TEST_SYNCLINE([Action synch line],
-[[%%
+[[%{
+void yyerror (const char *s);
+int yylex (void);
+%}
+%%
 exp:
 {
 exp:
 {
-#error "4"
+#error "8"
 };
 ]],
 };
 ]],
-[input.y:4: #error "4"
+[input.y:8: #error "8"
 ])
 
 
 ])
 
 
@@ -111,10 +160,14 @@ exp:
 ## --------------------- ##
 
 AT_TEST_SYNCLINE([Epilogue synch line],
 ## --------------------- ##
 
 AT_TEST_SYNCLINE([Epilogue synch line],
-[[%%
+[[%{
+void yyerror (const char *s);
+int yylex (void);
+%}
+%%
 exp: '0';
 %%
 exp: '0';
 %%
-#error "4"
+#error "8"
 ]],
 ]],
-[input.y:4: #error "4"
+[input.y:8: #error "8"
 ])
 ])